config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  resources :books
  get 'search_books' => 'books#search_books'

  resources :authors
  get 'search_authors' => 'authors#search_authors'

  resources :publishers
  get 'search_publishers' => 'publishers#search_publishers'

  root 'books#search_books'
end

app/models/book.rb
class Book < ApplicationRecord
  belongs_to :publisher
  belongs_to :author

  validates :publisher_id, :presence => {:message => "Kérjük, válasszon ki egy kiadót!" }
  validates :author_id, :presence => {:message => "Kérjük, válasszon ki egy szerzőt!" }

  BOOK_JOIN = Book.joins(:author, :publisher)
  BOOK_WITH_AUTHOR = Book.joins(:author).select("distinct on (author_id) *")

  def author_full_name
    "#{first_name} #{last_name}"
  end

  BOOK_WITH_PUBLISHER = Book.joins(:publisher).select("distinct on (publisher_id) *")

  def publisher_name
    "#{name}"
  end

  ALL_AUTHORS = Author.all

  def every_author
    "#{first_name} #{last_name}"
  end

  ALL_PUBLISHERS = Publisher.all

  def every_publisher
    "#{name}"
  end

  scope :find_all_by, -> (title, isbn, category, price_lower, price_upper, author, publisher, available) {
    @book_list = BOOK_JOIN.all
    @book_list = @book_list.where("title LIKE ?", "%#{title}%" ) if title.present?
    @book_list = @book_list.where("isbn LIKE ?", "%#{isbn}%" ) if isbn.present?
    @book_list = @book_list.where("category LIKE ?", "%#{category}%" ) if category.present?
    @book_list = @book_list.where("price BETWEEN ? AND ?", "#{price_lower}", "#{price_upper}" ) if price_lower.present? && price_upper.present?
    @book_list = @book_list.where("author_id = ?", "#{author}" ) if author.present?
    @book_list = @book_list.where("publisher_id = ?", "#{publisher}" ) if publisher.present?
    @book_list = @book_list.where("available = ?", available)
  }

  scope :find_all_available, -> (available = true) { where("available = ?", available) }
end

app/controllers/books_controller.rb
class BooksController < ApplicationController

  include CheckValues
  include InitializeValues

  before_action { initialize_params(title = "Könyv keresése", @book_list = Book::BOOK_JOIN.find_all_available) unless @clicked }
  before_action :set_profession, only: [:show, :edit, :update, :destroy]
  helper_method :calculate_page_idx_upper_bound, :check_boundaries, :convert_to_int

  InputParams = Struct.new(:author_id, :publisher_id)

  def search_books
    hash = params[:input]
    @input = InputParams.new(*hash&.values_at(*InputParams.members))

    title = params[:title]
    isbn = params[:isbn]
    category = params[:category]
    price_lower = convert_to_int(params[:price_lower], Book.minimum(:price)).to_i
    price_upper = convert_to_int(params[:price_upper], Book.maximum(:price)).to_i
    author = @input.author_id #convert_to_int(@input.author_id, Author.maximum(:id).to_i + 1).to_i if @input.author_id.present?
    publisher = @input.publisher_id #convert_to_int(@input.publisher_id, Publisher.maximum(:id).to_i + 1).to_i if @input.publisher_id.present?

    if price_lower > price_upper
      tmp = price_upper
      price_upper = price_lower
      price_lower = tmp
    end

    params[:price_lower] = price_lower if params[:price_lower].present?
    params[:price_upper] = price_upper if params[:price_upper].present?

    Rails.logger.info "pricelower: #{price_lower}"
    Rails.logger.info "priceupper: #{price_upper}"

    @per_page = convert_to_int(params[:per_page].to_i, 5)
    @per_page = 5 if @per_page.blank? || @per_page > 10 || @per_page < 3

    @current_page = convert_to_int(params[:page].to_i, 1)
    @current_page = check_boundaries(@current_page, calculate_page_idx_upper_bound(@book_list.count, @per_page))


    @clicked = is_clicked?(params[:title], params[:isbn], params[:category], params[:price_lower], params[:price_upper], params[:available])
    @available = is_available?(params[:available], @clicked)

    @book_list = Book::BOOK_JOIN.find_all_by(title, isbn, category, price_lower, price_upper, author, publisher, @available) if @clicked
    @book_list = @book_list.paginate(:page => @current_page, :per_page => @per_page)

    respond_to do |format|
      format.html { render :search_books }
      format.xml { render :xml => @book_list }
      format.json { render :json => @book_list }
    end
  end

  # felugro ablak(modal) megnyitasa uj oldal helyett
  def show
    respond_to do |format|
      format.js
    end
  end

  def edit; end

  def new
    @book = Book.new
  end

  def create
    @book = Book.new(valid_params)
    @book.id = Book.all.pluck(:id).max + 1
    if @book.save
      redirect_to search_books_path, notice: "A könyv <b>(#{h @book.title})</b> létrehozása sikeresen megtörtént!".html_safe
    else
      render :new
    end
  end

  def update
    if @book.update(valid_params)
      redirect_to search_books_path, notice: "A könyv <b>(#{h @book.title})</b> módosítása sikeresen megtörtént!".html_safe
    else
      render :edit
    end
  end

  def destroy
    @book.destroy
    redirect_to search_books_path, notice: "A könyv <b>(#{h @book.title})</b> törlése sikeresen megtörtént!".html_safe
  end

  private

  def valid_params
    params.require(:book).permit(:title, :isbn, :category, :price, :available, :author_id, :publisher_id)
  end

  # edit, destroy, update, show előtt lefutó metódus, amely a kódduplikálás ellen van
  def set_profession
    @book = Book.find_by_id(params[:id])
  end

end

app/helpers/book_helper.rb
module BookHelper

  include ApplicationHelper

  def show_book_message(title, isbn, category, price_lower, price_upper, author, publisher, available)
    msg = "<div class='alert alert-danger'>Nincs találat a következő kifejezésre: "
    msg +=  "<br>Cím: <b>#{h title}</b>" unless title.blank?
    # msg += ", " unless address.blank? && remarks.blank? && office_phone.blank? # vessző helyes használata miatt
    msg +=  "<br>ISBN: <b>#{h isbn}</b>" unless isbn.blank?
    msg +=  "<br>Kategória: <b>#{h category}</b>" unless category.blank?
    msg +=  "<br>Ár minimum: <b>#{h price_lower} Ft</b>" unless price_lower.blank?
    msg +=  "<br>Ár maximum: <b>#{h price_upper} Ft</b>" unless price_upper.blank?
    msg +=  "<br>Szerző: <b>#{h Author.find_by_id(author)&.first_name || "Nem található az adatbázisban!"}  </b>" unless author.blank?
    msg +=  "<b>#{h Author.find_by_id(author)&.last_name || '' } </b>" unless author.blank?
    msg +=  "<br>Kiadó <b>#{h Publisher.find_by_id(publisher)&.name || "Nem található az adatbázisban!" } </b>" unless publisher.blank?

    icon = available == "igen" ? is_available?(true, 16) : is_available?(false, 16)
    msg +=  "<br>Elérhető: <b>#{icon}</b>"
    msg += "</div>"
    msg.html_safe
  end

  def checkbox_available?(clicked, available)
    clicked ? available : true
  end

end

app/views/books/_book_modal.html.erb
<div id="book-modal" class="modal fade" role="dialog">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <!--<button type="button" class="close" data-dismiss="modal">&times;</button>-->
        <h3 class="modal-title" style="text-align: left">Könyv megtekintése</h3>
      </div>

      <div class="modal-body">
        <p> Cím: <span style="color: dodgerblue; "> <%=h @book.title %> </span> </p>
        <p> ISBN: <span style="color: dodgerblue; "> <%=h @book.isbn %> </span> </p>
        <p> Kategória: <span style="color: dodgerblue; "> <%=h @book.category %> </span> </p>
        <p> Ár: <span style="color: dodgerblue; "> <%=h @book.price.to_s + " Ft"%> </span> </p>
        <p> Kiadó: <span style="color: dodgerblue; "> <%=h Publisher.find_by_id(@book.publisher_id).name %> </span> </p>
        <p> Szerző: <span style="color: dodgerblue; "> <%=h Author.find_by_id(@book.author_id).last_name + " " + Author.find_by_id(@book.author_id).first_name%> </span> </p>
        <p> Elérhető:  <span style="color: dodgerblue; "> <%=h is_available?(@book.available, 16) %> </span> </p>
      </div>

      <div class="modal-footer">
        <button type="button" class="btn btn-danger" data-dismiss="modal">Bezárás</button>
      </div>
    </div>
  </div>
</div>

app/views/books/_form.html.erb
<%= form_with(model: @book, local: true) do |f| %>
  <div class="form-group">
    <%= render "shared/errors", object: @book %>
    <table class="table" style="align-content: center" style="width: 1000px">
      <tr>
        <td style = "width: 100%">
          <%= f.label :title, "Cím" %><br>
          <%= f.text_field :title, autofocus: true, placeholder: "Cím", class: "form-control" %><br>
        </td>
      </tr>

      <tr>
        <td>
          <%= f.label :isbn, "ISBN" %><br>
          <%= f.text_field :isbn, placeholder: "ISBN", class: "form-control" %><br>
        </td>
      </tr>

      <tr>
        <td>
          <%= f.label :category, "Kategória" %><br>
          <%= f.text_field :category, placeholder: "Kategória", class: "form-control" %><br>
        </td>
      </tr>

      <tr>
        <td>
          <%= f.label :price, "Ár (HUF)" %><br>
          <%= f.number_field :price, placeholder: "Ár (HUF)", class: "form-control"%><br>
        </td>
      </tr>

      <tr>
        <td>
          <%= f.label :price, "Szerző neve" %><br>
          <%= f.collection_select :author_id, Author.all, :id, :full_author_name, { include_blank: 'Válasszon egy szerzőt!'}, { :class => 'form-control' }%><br>
        </td>
      </tr>

      <tr>
        <td>
          <%= f.label :price, "Kiadó neve" %><br>
          <%= f.collection_select :publisher_id, Publisher.all, :id, :full_publisher_name, { include_blank: 'Válasszon egy kiadót!'}, { :class => 'form-control' }%><br>
        </td>
      </tr>

      <tr>
        <td>
          <%= f.label :available, "Elérhető" %>
          <%= f.check_box :available, {}, "true", "false" %><br><br>
        </td>
      </tr>
    </table>
    <%= f.submit "Mentés", class: "btn btn-success" %>
    <%= link_to 'Mégsem', search_books_path, class: 'btn btn-danger' %>
    <div style="text-align: right; margin-top: -35px"> <%= link_to 'Vissza a kereséshez', search_books_path, class: 'btn btn-primary' %> </div>
  </div>
<% end %>

app/views/books/edit.html.erb
<h1>Szerkesztés - <%= @book.title %></h1><br><br>
<%= render "form", book: @book %>

app/views/books/new.html.erb
<h1>Könyv hozzáadása </h1><br><br>
<%= render "form", book: @book %>

app/views/books/search_books.html.erb
 <div>
    <%= successful_action_msg(notice) %>
    <%= link_to 'Új könyv felvétele', new_book_path, class: 'btn btn-success' %>
    <%= link_to 'Új szerző felvétele', new_author_path, class: 'btn btn-success' %>
    <%= link_to 'Új kiadó felvétele', new_publisher_path, class: 'btn btn-success' %>
    <br><br>

    <%= form_tag search_books_path, :method => "get" do %>
      <div class="form-group">
        <label><b>Könyv keresése</b> - Szűrési feltételek </label>
        <table class="table" style="align-content: center">
          <tr>
            <td style="width: 50%"><%= text_field_tag(:title, params[:title], placeholder: "Cím", class: "form-control") %></td>
            <td colspan="2" style="width: 50%"><%= text_field_tag(:isbn, params[:isbn], placeholder: "ISBN", class: "form-control") %></td>
          </tr>
          <tr>
            <td style="width: 50%"><%= text_field_tag(:category, params[:category], placeholder: "Kategória", class: "form-control") %></td>
            <td style="width: 25%"><%= text_field_tag(:price_lower, params[:price_lower], placeholder: "Ár - Minimum", class: "form-control") %></td>
            <td style="width: 25%"><%= text_field_tag(:price_upper, params[:price_upper], placeholder: "Ár - Maximum", class: "form-control") %></td>
          </tr>
          <tr>
            <td style="width: 50%"><%= collection_select(:input, :publisher_id, Book::BOOK_WITH_PUBLISHER.all, :publisher_id, :publisher_name, { include_blank: 'Válasszon egy kiadót!'}, { :class => 'form-control' }) %></td>
            <td colspan="2" style="width: 50%"><%= collection_select(:input, :author_id, Book::BOOK_WITH_AUTHOR.all, :author_id, :author_full_name, { include_blank: 'Válasszon egy írót!'}, { :class => 'form-control' }) %></td>
          </tr>
          <tr>
            <td colspan="2" style="width: 10%" ><label>Elérhető </label>
              <%= check_box_tag(:available, "igen", checkbox_available?(@clicked, @available)) %><br>
              Találatok oldalanként
              <input id="per_page" name="per_page" min="3" max="10" type="number" class="form-control" value="<%= @per_page %>" style="width: 60px"/>
            </td>
          </tr>
          <tr>
            <td>
              <%= submit_tag "Keresés", class: "btn btn-primary" %>
            </td>
          </tr>
        </table>

      </div>
    <% end %>

    <% if @book_list.count == 0 %>
      <table class="table">
        <tr>
          <td scope="row">
            <%= show_book_message(params[:title], params[:isbn], params[:category], params[:price_lower], params[:price_upper], @input.author_id, @input.publisher_id ,params[:available]) %>
          </td>
        </tr>
      </table>
    <% end %>

    <% unless @book_list.nil? || @book_list.empty? %>
      <table>
        <tr>
          <th scope="row">
            Találatok száma: <span style = "color: green"> <%= @book_list.count %> </span>
          </th>
        </tr>
      </table>
      <br>
      <table class="table">
        <thead>
        <tr>
          <th scope="col">#</th>
          <th scope="col">Könyv címe</th>
          <th scope="col">Kiadó neve</th>
          <th scope="col">Kategória</th>
          <th scope="col">Könyv szerzője</th>
          <th scope="col">Ár</th>
          <th scope="col">Elérhető</th>
          <th scope="col" colspan="3" width="25%" style="text-align:center">Műveletek</th>
        </tr>
        </thead>
        <tbody>

        <% list_size = @book_list.count %>
        <% @book_list.each_with_index do |book, idx| %>
          <%= set_row_background(idx) %>
          <th scope="row"> <%= current_index(idx, list_size, @current_page, @per_page) %> </th>
          <td> <%= h book.title if book %> </td>
          <td> <%= h Publisher.find_by_id(book.publisher_id).name if book %> </td>
          <td> <%= h book.category if book %> </td>
          <td> <%= h Author.find_by_id(book.author_id).first_name + " " + Author.find_by_id(book.author_id).last_name if book %> </td>
          <td> <%= h book.price.to_s + " Ft" if book %> </td>
          <td> <%= is_available?(book.available, 30) if book %> </td>
          <td> <%= link_to 'Megtekintés',  book_path(book.id), remote: true, class: 'btn btn-info' %> </td>
          <td> <%= link_to 'Szerkesztés', edit_book_path(book.id), class: 'btn btn-warning'%> </td>
          <td> <%= link_to 'Törlés', book_path(book.id),
                           class: 'btn btn-danger',
                           method: :delete,
                           data: { confirm: "Biztosan törli a következőt?\n
    Cím: #{h book.title}
    ISBN: #{h book.isbn}
    Kategória: #{h book.category}
    Ár (HUF): #{h book.price}"} %></td>
          </tr>
        <% end %>
        </tbody>
      </table>
    <% end %>
  </div>

  <div class="row">
    <div class="col offset-4">
      <!-- ez a kódrészlet felel az egyes aloldalak linkként való megjelenítéséért -->
      <%= will_paginate @book_list, :previous_label => 'Előző', :next_label => 'Következő', renderer: WillPaginate::ActionView::Bootstrap4LinkRenderer %>
    </div>
  </div>

<!-- MODAL MEGNYITASA JS-sel - megtekintés -->
<div id='book-content'></div>

<!-- https://dev.to/morinoko/adding-custom-javascript-in-rails-6-1ke6 -->
<%= javascript_pack_tag 'message_alerts' %>

app/views/books/show.js.erb
$('#book-content').html("<%= j render 'book_modal', book: @book %>");
$('#book-modal').modal('show');